/*
        poker2.cpp      (AmigaOS specific main module)

        V1.00 - 031196  Kimmo Tervinen
        -----   ------  ----------------
        V0.01   031196  Ripped this file from FFeditor.cpp
        V0.20   130297  Edited a lot to suit with poker.
        V0.50   190297  Ready Program if linked with ixemul.
                        But linking with libnix causes GURUs.
        V0.51   200297  Linking with libnix success.
*/

#include <inline++/exec.h>
#include <inline++/intuition.h>
#include <inline++/dos.h>
#include <inline++/graphics.h>
#include <inline++/gadtools.h>
#include <inline++/asl.h>
#include <inline++/iffparse.h>
#include <inline++/icon.h>
#include <intuition/intuition.h>
#include <intuition/screens.h>
#include <graphics/text.h>
#include <libraries/gadtools.h>
#include <workbench/startup.h>
#include <workbench/workbench.h>

#include "cstring.h"

#include "poker.h"
#include "game.h"
#include "pokermenu.h"
#include "pokergadgets.h"
#include "card.h"

extern WBStartup *_WBenchMsg;

extern long LoadBlocks(BitMap &,UBYTE*,UBYTE*);  // load Gfx
extern void FreeBlocks(BitMap &);                // free Gfx
extern void ReMapBitMap(BitMap &,RastPort *,const UBYTE *); // ReMap Gfx
extern int IDCMP(const IntuiMessage *,cIMGCard *const*);

UBYTE gfxpens[256];
UBYTE pens[2];

UBYTE *PubScreenName=NULL;

TextFont *TEXTFONT=NULL;


int My_main(void)
{
  int RT=20,colors;
  LONG olddir = -1;
  BitMap Cards={0,0,0,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
  Screen *Scr=NULL;
  Window *Wnd=NULL;
  ColorMap *cm=NULL;
  UBYTE ColorTable[256*3];
  int   prefsjoker=FALSE,prefs5kind=FALSE,
        changes=1,jokers=3;
  cstring CardFile="gfx/defaultcards.lbm";

// Varmista, ett levy-kirjastot ovat auki. Jos ei - niin guruta ja poistu

  if(!IFFParseBase) {
    UBYTE errortext[] = "\0\100\20iffparse.library\1\1";
    DisplayAlert(0L,errortext,40L);
    return RT;
  }
  if(!GadToolsBase) {
    UBYTE errortext[] = "\0\100\20gadtools.library\1\1";
    DisplayAlert(0L,errortext,40L);
    return RT;
  }
  if(!AslBase) {
    UBYTE errortext[] = "\0\100\20asl.library\1\1";
    DisplayAlert(0L,errortext,40L);
    return RT;
  }
  if(!IconBase) {
    UBYTE errortext[] = "\0\100\20icon.library\1\1";
    DisplayAlert(0L,errortext,40L);
    return RT;
  }

#if 1
  if(!_WBenchMsg) {
    Write(Output(),"Start this program from WB\n",28);
    return 10;
  }
#endif


// Read preferences from TOOLTYPEs

//    UBYTE errortext[] = { 0,100,20,'t','e','s','t','i','n','g',0,0 };
//    DisplayAlert(0L,errortext,40L);


  {
    struct DiskObject *dobj;
    UBYTE **toolarray;
    UBYTE *s;
    WBArg *wbarg=_WBenchMsg->sm_ArgList;
    if((wbarg->wa_Lock)&&(*wbarg->wa_Name))
      olddir=CurrentDir(wbarg->wa_Lock);

    if((*wbarg->wa_Name) && (dobj=GetDiskObject((UBYTE*)wbarg->wa_Name)))
    {
      toolarray = (UBYTE**)dobj->do_ToolTypes;

      if(s=FindToolType(toolarray,(UBYTE*)"PREFSJOKER"))
        if(MatchToolValue(s,(UBYTE*)"TRUE"))
          prefsjoker=TRUE;

      if(s=FindToolType(toolarray,(UBYTE*)"PREFS5KIND"))
        if(MatchToolValue(s,(UBYTE*)"TRUE"))
          prefs5kind=TRUE;

      if(s=FindToolType(toolarray,(UBYTE*)"CHANGES"))
        changes=s[0]-'0';
      if(changes<1) changes=1;
      if(changes>MAX_CHANGES) changes=MAX_CHANGES;

      if(s=FindToolType(toolarray,(UBYTE*)"JOKERS"))
        jokers=s[0]-'0';
      if(jokers<0) jokers=0;
      if(jokers>MAX_JOKERS) jokers=MAX_JOKERS;

      if(s=FindToolType(toolarray,(UBYTE*)"CARDS"))
        CardFile=s;

      FreeDiskObject(dobj);
    }

  }

// Opening Font

  {
    const TextAttr textattr={ (UBYTE*)"topaz.font",8,0,0 };
    if(!(TEXTFONT=OpenFont(&textattr))) goto cleanup;
  }

  {

// Load Card graphics, if fail show requester

    RT=LoadBlocks(Cards,ColorTable,CardFile);
    if(RT) {
      EasyStruct myES = {
        sizeof(struct EasyStruct),0,
        (UBYTE*)"Destructive Poker",
        (UBYTE*)"Error while loading Card GFX file \"%s\"",
        (UBYTE*)"QUIT"
      };
      EasyRequest(NULL, &myES, NULL, (ULONG)CardFile.chars());
      goto cleanup;
    }


    if(!(Scr=LockPubScreen(PubScreenName))) goto cleanup;

  }


  {
    {
      int BTop = Scr->WBorTop + (Scr->Font->ta_YSize + 1);
      struct TagItem window_tags[] = {
        { WA_Title, (long unsigned)"Destructive Poker" },
        { WA_DragBar , TRUE},
        { WA_DepthGadget , TRUE},
        { WA_CloseGadget, TRUE },
        { WA_Left, (Scr->Width-600)/2 },
        { WA_Top, (Scr->Height-230-BTop)/2 },
        { WA_Width, 600 }, { WA_Height, 230+BTop },
        { WA_CustomScreen, (ULONG)Scr },
        { WA_Activate, TRUE},
        { WA_IDCMP, IDCMP_VANILLAKEY |
                    IDCMP_MOUSEBUTTONS |
                    IDCMP_MOUSEMOVE |
                    IDCMP_MENUPICK |
                    IDCMP_GADGETUP |
                    IDCMP_REFRESHWINDOW |
                    IDCMP_CLOSEWINDOW },
        { TAG_DONE, NULL}
      };
      RT=22;
      Wnd=OpenWindowTagList(NULL,window_tags);
    }


    if(Wnd)
    {
      SetFont(Wnd->RPort,TEXTFONT);

      Move(Wnd->RPort,8+Wnd->BorderLeft,8+Wnd->BorderTop);    // Print Double
      SetAPen(Wnd->RPort,TEXT_PEN); SetDrMd(Wnd->RPort,JAM1);  // Text
      Text(Wnd->RPort,(UBYTE*)"Wait! Remapping graphics..",26); //

      if(cm=Scr->ViewPort.ColorMap)
      {
        // Allocate colors and remap graphics
        colors = 1<<Cards.Depth;

        for(int i=0; i<colors ; i++ ) {
          gfxpens[i] = ObtainBestPen(cm,
                                (ULONG)ColorTable[3*i]*0x1010101,
                                (ULONG)ColorTable[3*i+1]*0x1010101,
                                (ULONG)ColorTable[3*i+2]*0x1010101,
                                0x84000000,0xFFFFFFFF,
                                TAG_DONE);
        }
        ReMapBitMap(Cards,&Scr->RastPort,gfxpens);
        pens[0] = ObtainBestPen(cm,0xACACACAC,
                                   0xACACACAC,
                                   0xACACACAC,
                                   0x84000000,0xFFFFFFFF,
                                   TAG_DONE);
        pens[1] = ObtainBestPen(cm,0,0,0,
                                   0x84000000,0xFFFFFFFF,
                                   TAG_DONE);
      }

      SetABPenDrMd(Wnd->RPort,gfxpens[0],gfxpens[0],JAM1);
      RectFill(Wnd->RPort,Wnd->BorderLeft,Wnd->BorderTop,
                          Wnd->Width-Wnd->BorderRight,
                          Wnd->Height-Wnd->BorderBottom);

      Move(Wnd->RPort,150+Wnd->BorderLeft,23+Wnd->BorderTop);    // Print Double
      SetAPen(Wnd->RPort,pens[1]); SetDrMd(Wnd->RPort,JAM1);  // Text
      Text(Wnd->RPort,(UBYTE*)"Money:",6); //

      RefreshWindowFrame(Wnd);

      {
        int terminated=FALSE;
        cGamePoker gamepoker(Wnd,&Cards,prefsjoker,prefs5kind,changes,jokers);
        cPokerMenu menu(Wnd,&gamepoker);
        cPokerGadgets pokergads(Wnd,&gamepoker);
        cIMGCard *const*cards=gamepoker.Cards();

        while(!terminated) {
          Message *msg;

          WaitPort(Wnd->UserPort);
          while(msg=GetMsg(Wnd->UserPort)) {

            if((RT=menu.IDCMP((const IntuiMessage *)msg))==IDCMP_NOT_DONE)
              if((RT=pokergads.IDCMP((const IntuiMessage *)msg))==IDCMP_NOT_DONE)
                if((RT=IDCMP((const IntuiMessage *)msg,cards))==IDCMP_NOT_DONE)
                  switch(((IntuiMessage *)msg)->Class) {
                    case IDCMP_CLOSEWINDOW:
                        {
                          EasyStruct myES = {
                            sizeof(struct EasyStruct),0,
                            (UBYTE*)"Quit Poker",
                            (UBYTE*)"Are You Sure to Quit?",
                            (UBYTE*)"Quit|Cancel"
                          };
                          switch(EasyRequestArgs(Wnd, &myES, NULL, NULL)) {
                            case 1: terminated=TRUE;
                            case 0: break;
                          }
                        }
                    break;
                  }
            if(RT==IDCMP_TERMINATED) terminated=TRUE;
            if(RT!=IDCMP_REPLYED) ReplyMsg(msg);
          }
        }

        prefsjoker=gamepoker.PrefsJoker();
        prefs5kind=gamepoker.Prefs5Kind();
        changes=gamepoker.Changes();
        jokers=gamepoker.Jokers();

        // Save preferences to Tool Types
        {
          struct DiskObject *dobj;
          char **oldtooltypes;
          LONG odir=-1;
          WBArg *wbarg=_WBenchMsg->sm_ArgList;
          if((wbarg->wa_Lock)&&(*wbarg->wa_Name))
            odir=CurrentDir(wbarg->wa_Lock);


          if((*wbarg->wa_Name) && (dobj=GetDiskObject((UBYTE*)wbarg->wa_Name)))
          {
            char *newtooltypes[]={
              { "PREFSJOKER=FALSE"},
              { "PREFS5KIND=FALSE"},
              { "CHANGES=0"},
              { "JOKERS=0"},
              NULL,
              NULL
            };
            cstring tooltype="CARDS=";
            tooltype+=CardFile;

            if(prefsjoker) newtooltypes[0]="PREFSJOKER=TRUE";
            if(prefs5kind) newtooltypes[1]="PREFS5KIND=TRUE";
            newtooltypes[2][8]+=changes;
            newtooltypes[3][7]+=jokers;
            newtooltypes[4]=(char*)tooltype.chars();

            oldtooltypes = dobj->do_ToolTypes;

            dobj->do_ToolTypes = newtooltypes;

            PutDiskObject((UBYTE*)wbarg->wa_Name,dobj);

            dobj->do_ToolTypes = oldtooltypes;

            FreeDiskObject(dobj);
          }
          if(odir != -1) CurrentDir(odir); /* CD back where we were */
        }

        CloseWindow(Wnd);
        RT=0;
      }
    }
  }

cleanup:
    if(olddir != -1) CurrentDir(olddir); /* CD back where we were */

  if(Scr) {
    if (cm) {
      for (int i = 0; i < colors ; i++) ReleasePen(cm,gfxpens[i]);
      ReleasePen(cm,pens[0]);
      ReleasePen(cm,pens[1]);
    }
    UnlockPubScreen(PubScreenName,Scr);
  }

  FreeBlocks(Cards);

  if(TEXTFONT) CloseFont(TEXTFONT);
  return RT;
}
